package com.prodega.proshop.integration.spi;

import java.io.PrintWriter;

import javax.naming.Reference;
import javax.resource.ResourceException;
import javax.resource.spi.ConnectionManager;
import javax.resource.spi.ConnectionRequestInfo;
import javax.resource.spi.ManagedConnectionFactory;

import org.apache.log4j.Logger;

import com.prodega.proshop.integration.IODataSource;

public class IODataSourceImpl implements IODataSource {

	private final static Logger LOGGER = Logger.getLogger(IODataSourceImpl.class);

	private static final long serialVersionUID = 1L;
	private ManagedConnectionFactory mcf;
	private Reference reference;
	private ConnectionManager cm;

	public IODataSourceImpl(PrintWriter out, ManagedConnectionFactory mcf, ConnectionManager cm) {
		LOGGER.debug("FileDataSource");
		this.mcf = mcf;
		this.cm = cm;
	}

	public IOConnectionImpl getConnection() {
		LOGGER.debug("FileDataSource.getConnection " + this.cm + " MCF: " + this.mcf);
		try {
			return (IOConnectionImpl) cm.allocateConnection(mcf, getConnectionRequestInfo());
		} catch (ResourceException ex) {
			throw new RuntimeException(ex);
		}
	}

	public void setReference(Reference reference) {
		this.reference = reference;
	}

	public Reference getReference() {
		return reference;
	}

	private ConnectionRequestInfo getConnectionRequestInfo() {
		return new ConnectionRequestInfo() {

			@Override
			public boolean equals(Object obj) {
				return true;
			}

			@Override
			public int hashCode() {
				return 1;
			}
		};
	}
}
