package com.prodega.proshop.integration.spi;

import java.io.FileOutputStream;
import java.io.IOException;

import com.prodega.proshop.integration.exceptions.IOTransactionException;

public class WriteAction implements TransactionalAction {

	private String fileName;
	private byte[] content;

	public WriteAction(String fileName, byte[] content) {
		super();
		this.fileName = fileName;
		this.content = content;
	}

	@Override
	public void commit() {
		try {
			FileOutputStream fileOutputStream = new FileOutputStream(fileName, false);
			fileOutputStream.write(content);
			fileOutputStream.close();
		} catch (IOException ex) {
			throw new IOTransactionException(ex);
		}
	}

	@Override
	public void rollback() {
	}

	public String getFileName() {
		return fileName;
	}

	public void setFileName(String fileName) {
		this.fileName = fileName;
	}

	public byte[] getContent() {
		return content;
	}

	public void setContent(byte[] content) {
		this.content = content;
	}

}
